package problem_1;

public class DogTest {

	public static void main(String[] args) {
		testDogCreation();
		testBark();
		testBarkAt();
		testCounterOlder();
	}
	
	public static void testDogCreation() {
		System.out.println("-->testDogCreation()");
		Dog d1 = new Dog("Cosmos");
		Dog d2 = new Dog("Fancy", 3);
		
		String expected = "Expected: Dog name is: Cosmos, age is: 1\n"
						+ "Dog name: is Fancy, age is: 3";
		String actual = "Actual: " + d1 + d2;
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	public static void testBark() {
		System.out.println("\n-->testBark()");
		Dog d1 = new Dog("Cosmos");
		
		String bark = d1.bark(3);
		
		String expected = "Expected: bark bark bark";
		String actual = "  Actual: " + bark;
		
		System.out.println(expected);
		System.out.println(actual);
	}
	
	public static void testBarkAt() {
		System.out.println("\n-->testBarkAt()");
		Dog d1 = new Dog("Cosmos");
		Dog d2 = new Dog("Fancy", 3);
		
		String barkAt1 = d1.barkAt(d2);
		String barkAt2 = d2.barkAt(d1);
		
		String expected1 = "Expected: Cosmos barks at Fancy";
		String actual1 = "  Actual: " + barkAt1;
		
		String expected2 = "Expected: Fancy barks at Cosmos";
		String actual2 = "  Actual: " + barkAt2;
		
		System.out.println(expected1);
		System.out.println(actual1);
		System.out.println(expected2);
		System.out.println(actual2);
	}
	
	public static void testCounterOlder() {
		System.out.println("\n-->testCounterOlder()");
		Dog[] dogs = createDogArray_5_Dogs();
		Dog d = new Dog("Triton", 5);
		
		int count = d.countOlder(dogs);

		String expected = "Expected: There are 3 dogs older than Triton.";
		String actual = String.format("  Actual: There are %d dogs older than %s",
										count, d.getName());
		
		System.out.println(expected);
		System.out.println(actual);
	} 
	
	public static void testGetEveryOtherEven() {
		System.out.println("\n-->testGetEveryOtherEven()");
	}
	
	
	 /* Helper method */
	 private static Dog[] createDogArray_5_Dogs() {
		 Dog[] dogs = new Dog[5];
		 dogs[0] = new Dog("Cosmos");
		 dogs[1] = new Dog("Fancy", 3);
		 dogs[2] = new Dog("Reji", 7);
		 dogs[3] = new Dog("Bongo", 9);
		 dogs[4] = new Dog("Glinda", 8);
		 
		 return dogs;
	 }
}
