package problem_1;

public class DogUtilities {

	public Dog[] getEveryOther(Dog[] dogs) {
		// Calculate length of new array
		int len;
		if(dogs.length%2==0) {
			len = dogs.length/2;
		}
		else {
			len = dogs.length/2 + 1;
		}
		
		// Or, a shorter way
		len = (dogs.length+1)/2;
		
		Dog[] newDogArray = new Dog[len];
		
		int j = 0;
		for(int i=0; i<dogs.length; i++) {
			if(i % 2 == 0) {
				newDogArray[j] = dogs[i];
				j++;
			}
		}
		return newDogArray;
	}

	public Dog[] getEveryOtherEven(Dog[] dogs) {
		int numDogs = dogs.length;
		double lengthNewArray = Math.ceil(numDogs/2.0);
		Dog[] newDogArray = new Dog[(int) (lengthNewArray)];
		
		int j = 0;
		for(int i = 0; i < dogs.length; i++) {
			if(i % 2 == 0) {
				newDogArray[j] = dogs[i];
				j++;
			}
		}
		return newDogArray;
	}
	
	public Dog[] getEveryOtherOdd(Dog[] dogs) {
		int numDogs = dogs.length;
		double lengthNewArray = Math.floor(numDogs/2.0);
		Dog[] newDogArray = new Dog[(int) (lengthNewArray)];
		
		int j = 0;
		for(int i = 0; i < dogs.length; i++) {
			if(i % 2 == 1) {
				newDogArray[j] = dogs[i];
				j++;
			}
		}
		return newDogArray;
	}
	
	public Dog[] createMutants(Dog[] dogs) {
		Dog[] newDogArray = new Dog[dogs.length];
		
		for(int i = 0; i < dogs.length; i++) {
			String name = dogs[i].getName().substring(1, dogs[i].getName().length()-1);
			int age = dogs[i].getAge();
			newDogArray[i] = new Dog(name, age);	
		}
		return newDogArray;
	}
	
}
